# 实验1 实验报告

## 实验要求

完成本次布置的4个实验。

## 求解思路

### 1. 进制16

新建文件夹，放置 `test.txt` 和 `main.py` 两个文件。

找一个 OCR 识别网站，识别图片信息

```text
20 61 20 62 79 ...
```

选取16进制对应的信息放在 `test.txt` 里。

`main.py`:

```python
while True:
    try:
        nums = input().split()
    except Exception:
        print()
        exit(0)

    for val in nums:
        print(chr(int(val, 16)), end='')
```

运行：

```bash
python main.py < test.txt
```

可以得到对应的字符。

### 2. 2048

根据 F12 审查元素可以找到代码提交的文件在 `static/js/html_actuator.js` 里。

找到对应的行：

![11](./img/11.png)

在 145 和 146 行之间加一句：

```javascript
won=true;
```

这样只需要尽快结束游戏就能得到通关的效果了。

结束游戏之后在 F12 网络一栏找到对应的包，点击预览即可看到对应的 flag

#### 其他思路

后来发现，可以截取上边函数的一部分直接在控制台运行：

```js
message = function (won) {
  var type    = won ? "game-won" : "game-over";
  var message = won ? "FLXG 大成功！" : "FLXG 永不放弃！";

  var url;
  if (won) {
    url = "/getflxg?my_favorite_fruit=" + ('b'+'a'+ +'a'+'a').toLowerCase();
  } else {
    url = "/getflxg?my_favorite_fruit=";
  }

  let request = new XMLHttpRequest();
  request.open('GET', url);
  request.responseType = 'text';

  request.onload = function() {
    document.getElementById("game-message-extra").innerHTML = request.response;
  };

  request.send();
}
```

输入到控制台，执行 `message(true)` 即可不用结束游戏也能得到对应的网络包。

### 3. 虚假的安全

经过尝试发现这个其实是已知一对明文和密文的攻击。

根据题意，打印结果的前五个是 `flag{` 对应的密文，因此可以由此破解明文。由异或性质知，明文和密文异或得到密钥。

```python
msg = "flag{"
key = ""
secret = [14, 13, 17, 55, 2]
for i in range(len(msg)):
    key += chr(ord(msg[i])^secret[i])

print(key)
```

输出 key 为 `hapPy` ，再与全部密文异或可以得到明文。

### 4. 你的名字

首先在某一行把按钮的 disable 给删掉，按钮就能用了。持续尝试可以发现，该按钮执行下面 script 的 click 里边的函数。

该代码无法直接修改，复制下来写一个可以直接执行的函数：

```js{.line-numbers}
sender = function () {//点击按钮时执行的函数
$.ajax({
            url: "",//发送一个到当前网址的post请求
            type: "POST",
            data: { "name": "张广为", "token": "xxxx" },
            dataType: "text",
            success: function (data) {
              $("#msg").html(data);
            }
          });
      }
```

复制自己的 token 修改上文第5行的代码，执行一次可以发现，“网络”里的“预览”出现了对应的flag

## 思考题

- 为什么 ('b'+'a'+ +'a'+'a').toLowerCase() 的运行结果是 banana ， js 执行这段代码究竟是什么逻辑？

  答：首先括号标记一下计算优先级：

  ```text
  'b' + 'a' + + 'a' + 'a'
  'b' + 'a' + (+ 'a') + 'a'
  ```

  因为 `(+ 'a')` 在执行的时候，首先尝试把 `'a'` 转化成数值，但是只能转化成 NaN ；随后和其他字符相加：

  ```text
  'b' + 'a' + Number('a') + 'a'
  'b' + 'a' + NaN + 'a'
  ```

  相加结果是 `baNaNa` ，转化成小写的结果是 `banana`
