# 实验6

## 2.1 TCP

关闭浏览器和 QQ 等软件后，执行实验步骤如图：

![1](img/1.png)

使用 `ifconfig` 查询本级 IP 地址：114.214.218.24（中校区 eduroam）

对应 TCP 三次握手数据：

|项目|数值|
|-|-|
|发送方 IP 地址和端口号|114.214.218.24:35920|
|接收方 IP 地址和端口号|93.184.218.34：80|

|项目|握手包1|握手包2|握手包3|释放包1|释放包2|释放包3|
|-|-|-|-|-|-|-|
|Seq号|0|0|1|80|1592|81|
|Ack号|/|1|1|1592|81|1693|
|Flags|SYN|SYN,ACK|ACK|FIN,ACK|FIN,ACK|ACK|
|Window|65535|64256|65536|64128|65536|64128|

## 2.2 HTTP/HTTPS

|指令|协议版本|方法类型|状态码|内容类型|
|-|-|-|-|-|
|curl -v http://www.example.com|HTTP1.1|GET|200|text/html|
|curl -v https://www.example.com|HTTP1.1|GET|200|text/html|
|curl -v -d "user=test" -X POST http://example.com/login|HTTP1.1|POST|404|text/html|
## 2.3 DNS

|项目|数据|
|-|-|
|本机 IP 地址和端口号|114.214.218.24:47995|
|DNS 服务器 IP 地址和端口号|202.38.64.56:53|
|传输层协议类型|UDP|
|目标服务器 URI|http://www.example.com/|
|目标服务器 IP 地址|93.184.216.34|

查询本机 DNS：

```bash
$ cat /etc/resolv.conf 
# Generated by NetworkManager
search ustc.edu.cn
nameserver 202.38.64.56
nameserver 202.38.64.17
```

确实在本机 DNS 位置。

指定服务器：

```bash
$ sudo vim /etc/resolv.conf
# 第二行添加 nameserver 8.8.8.8
```

|查询目标|命令|结果|
|-|-|-|
|www.baidu.com 的 IPv4 地址|dig www.baidu.com @8.8.8.8|182.61.200.7(CNAME www.a.shifen.com)|
|jw.ustc.edu.cn 的 IPv6 地址|dig -t aaaa jw.ustc.edu.cn @8.8.8.8|2001:da8:d800:642::248|
|202.38.75.11 的域名|dig -x 202.38.75.11 @8.8.8.8|infonet.ustc.edu.cn|
|mail.ustc.edu.cn 的邮件交换记录|dig mx mail.ustc.edu.cn|10 smtp.ustc.edu.cn|
|i.ustc.edu.cn 的 CNAME|dig i.ustc.edu.cn|revproxy.ustc.edu.cn|
example.com 的域名服务器|a.iana-servers.net|dig example.com +trace|

![2](img/2.png)

可以查询13台根域名服务器。

![3](img/3.png)

由结果可以知道，不能得到有效的DNS查询结果。

## 2.4 FTP

主动模式：

![5](img/5.png)

使用 21 号端口。

被动模式：

![4](img/4.png)

Entering Passive Mode (202,38,64,10,32,51)得到 $32\times256+51=8243$

## 思考题

1. 解释 HTTP 中的幂等是什么意思?
   答：幂等指 HTTP 中同样的请求被执行一次与重读多次的效果相同、服务器的状态一样。
2. GET操作是幂等的吗?POST呢?
   答：GET 是，POST 不是。
3. HTTPS抓到的数据包与之前的HTTP中抓到的有何不同?这是什么原因导致的?
   答：HTTPS 得到的数据包无法直接看到内容，因为 HTTPS 对数据有加密。
4. 解释从输入网址到浏览器显示网页，在应用层依次发生了什么?
   答：
   - 浏览器把 URL 发送给 DNS，DNS 解析为 IP 地址。
   - 浏览器使用 IP 地址发送 HTTP请求。
   - 服务器接受请求，会返回 HTML 等资源文件。
   - 浏览器接收并解析 HTML 文件，如有需要还需包括 JS 文件等。
   - 浏览器解析网页资源文件，渲染成网页并显示在屏幕上。
